Bug 479973 - btrfs: shrinking fs doesn't work so good
btrfs: shrinking fs doesn't work so good
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
11
All Linux
low Severity medium
: ---
: ---
Assigned To: Josef Bacik
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-01-14 06:33 EST by Pavel Morozov
Modified: 2010-06-28 07:06 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 07:06:19 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Pavel Morozov 2009-01-14 06:33:24 EST
[lapt2 Download]$ sudo  btrfsctl -r -4g /mnt/1/btrfs_test1/
operation complete
Btrfs Btrfs v0.17
[lapt2 Download]$ df -h
Filesystem            Size  Used Avail Use% Mounted on
/dev/mapper/VolGroup00-LogVol00
                      102G   39G   58G  40% /
/dev/sda5             198M   29M  159M  16% /boot
tmpfs                 990M  288K  990M   1% /dev/shm
/dev/sda3             5.8G  3.5G  2.3G  61% /mnt/1
[lapt2 Download]$ sudo su -
[root@lapt2 ~]# cd /mnt/1/
[root@lapt2 1]# cd btrfs_test1/
[root@lapt2 btrfs_test1]# btrfsctl -r -1g /mnt/1
Segmentation fault
[root@lapt2 btrfs_test1]# 
Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel:------------[ cut here ]------------

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel:invalid opcode: 0000 [#1] SMP DEBUG_PAGEALLOC

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel:last sysfs file: /sys/devices/LNXSYSTM:00/device:00/PNP0C0A:00/power_supply/CMB1/charge_full

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel:Process btrfsctl (pid: 26037, ti=c59c6000 task=c419d400 task.ti=c59c6000)

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel:Stack:

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: 00000000 c59c68c7 ffffffff f136b950 c59c6848 f87b4aaf 00001000 00000000

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: 00001000 00000000 00000000 00000000 dc830000 00000000 ffffffff ffffffff

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel:Call Trace:

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87b4aaf>] ? btrfs_reserve_extent+0x35/0x58 [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87c5658>] ? cow_file_range+0x1fa/0x3b5 [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87c5f05>] ? run_delalloc_range+0x85/0x2f0 [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87d8e7a>] ? __extent_writepage+0x209/0x8aa [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c04495b5>] ? clocksource_get_next+0xd/0x43

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c04495b5>] ? clocksource_get_next+0xd/0x43

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c044e03f>] ? trace_hardirqs_off_caller+0x18/0xa3

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c047e32c>] ? find_get_pages_tag+0xb1/0xd8

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87d6757>] ? extent_write_cache_pages+0x14d/0x230 [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87c3b3c>] ? btrfs_writepages+0x0/0x1f [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87d686b>] ? extent_writepages+0x31/0x53 [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87d8c71>] ? __extent_writepage+0x0/0x8aa [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87d521b>] ? flush_write_bio+0x0/0x26 [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87c3c68>] ? btrfs_get_extent+0x0/0x815 [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87c3b56>] ? btrfs_writepages+0x1a/0x1f [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c048423d>] ? do_writepages+0x23/0x34

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c04bc8ae>] ? __writeback_single_inode+0x15a/0x293

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c04bcd8d>] ? generic_sync_sb_inodes+0x234/0x303

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c04bcd8d>] ? generic_sync_sb_inodes+0x234/0x303

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c04bcd3d>] ? generic_sync_sb_inodes+0x1e4/0x303

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c04bcffe>] ? writeback_inodes+0x85/0xcc

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c0484a6e>] ? balance_dirty_pages_ratelimited_nr+0x128/0x232

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87b2a4c>] ? relocate_inode_pages+0x2bb/0x311 [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87b2be5>] ? relocate_data_extent+0x143/0x163 [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87b85d7>] ? relocate_one_extent+0x16b/0x33d [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87c02d5>] ? btrfs_end_transaction+0xa/0xc [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87b2708>] ? __alloc_chunk_for_shrink+0x104/0x11b [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87b89fd>] ? btrfs_relocate_block_group+0x254/0x3dc [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87dc2f1>] ? btrfs_relocate_chunk+0x4d/0x42a [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87d4ca4>] ? map_extent_buffer+0x69/0xa0 [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c044ed4f>] ? trace_hardirqs_on_caller+0x18/0x145

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c044ee87>] ? trace_hardirqs_on+0xb/0xd

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87dc935>] ? btrfs_shrink_device+0x267/0x286 [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87e0587>] ? btrfs_ioctl+0x614/0x89d [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c0511bbb>] ? inode_has_perm+0x58/0x62

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c046b12f>] ? audit_filter_rules+0x0/0x7ac

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<f87dff73>] ? btrfs_ioctl+0x0/0x89d [btrfs]

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c04b0e23>] ? vfs_ioctl+0x22/0x69

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c04b1398>] ? do_vfs_ioctl+0x46a/0x4a3

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c0511f41>] ? selinux_file_ioctl+0x3e/0x42

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c04b1411>] ? sys_ioctl+0x40/0x5a

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c0403b76>] ? syscall_call+0x7/0xb

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel: [<c06e007b>] ? acpi_processor_start+0x45d/0x6e3

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel:Code: 08 89 d8 8b 4d 0c 83 c4 2c e8 ad 0b 03 00 8b 45 e4 e8 bd e1 f2 c7 8b 3f 8b 07 0f 18 00 90 3b 7d e0 75 8b 8b 45 e8 e8 c8 01 c9 c7 <0f> 0b eb fe 8d 65 f4 31 c0 5b 5e 5f 5d c3 55 89 e5 57 89 d7 56 

Message from syslogd@lapt2 at Jan 14 13:01:34 ...
 kernel:EIP: [<f87b4a6c>] __btrfs_reserve_extent+0x32d/0x33b [btrfs] SS:ESP 0068:c59c67d0
Comment 1 Josef Bacik 2009-01-28 15:09:19 EST
thanks I've reproduced this locally, I'll work on a fix.
Comment 2 Josef Bacik 2009-02-03 15:35:35 EST
this is getting prioritized other more important things, basically don't shrink your fs too close to how much is currently used, otherwise it will panic.  I'll throw this on the TODO list.
Comment 3 Bug Zapper 2009-06-09 06:43:00 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 11 development cycle.
Changing version to '11'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Bug Zapper 2010-04-27 08:44:18 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Bug Zapper 2010-06-28 07:06:19 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.